<?php
class FrmPaymentsController{
    function FrmPaymentsController(){
        add_action('admin_menu', array( &$this, 'menu' ), 26);
        add_filter('frm_nav_array', array( &$this, 'frm_nav'), 30);
        add_filter('manage_formidable_page_formidable-payments_columns', array(&$this, 'payment_columns'));
        add_filter('plugin_action_links_formidable-paypal/formidable-paypal.php', array( &$this, 'settings_link'), 10, 2 );
        add_action('admin_notices', array( &$this, 'get_started_headline'));
        add_action('admin_init', array( &$this, 'include_updater'), 1);
        register_activation_hook(FRM_PAYMENT_PATH.'/formidable-paypal.php', array( &$this, 'install' ));
        add_action('wp_ajax_frmpay_install', array( &$this, 'install' ));
        
        add_action('frm_after_create_entry', array( &$this, 'redirect_for_payment'), 50, 2);
        add_action('frm_entry_form', array( &$this, 'hidden_payment_fields' ));
        
        add_filter('frm_setup_new_form_vars', array(&$this, 'setup_new_vars'));
        add_filter('frm_setup_edit_form_vars', array(&$this, 'setup_edit_vars'));
        add_filter('frm_form_options_before_update', array(&$this, 'update_options'), 15, 2);
        add_action('frm_show_entry_sidebar', array(&$this, 'sidebar_list'));
        
        add_action('frm_standalone_route', array(&$this, 'standalone_route'), 10, 2);
    }

    function menu(){
        global $frm_payment_settings_controller;
        add_submenu_page(FRM_PLUGIN_NAME, FRM_PLUGIN_TITLE .' | '. __('Payments', 'formidable'), __('Payments', 'formidable'), 'frm_view_entries', 'formidable-payments', array(&$this, 'route'));
        add_submenu_page(FRM_PLUGIN_NAME, FRM_PLUGIN_TITLE .' | '. __('Payment Settings', 'formidable'), __('Payment Settings', 'formidable'), 'frm_change_settings', 'formidable-payment-settings', array(&$frm_payment_settings_controller, 'route'));
    }
    
    function frm_nav($nav){
        if(current_user_can('frm_view_entries'))
            $nav['formidable-payments'] = __('Payments', 'formidable');
            
        if(current_user_can('frm_change_settings'))
            $nav['formidable-payment-settings'] = __('Payment Settings', 'formidable');
            
        return $nav;
    }
    
    function payment_columns($cols){
        include_once( FRM_PAYMENT_PATH . "/helpers/FrmPaymentsListHelper.php" );
        return FrmPaymentsListHelper::get_columns();
    }
    
    // Adds a settings link to the plugins page
    function settings_link($links, $file){
        $settings = '<a href="'.admin_url('admin.php?page=formidable-payment-settings').'">' . __('Settings', 'formidable') . '</a>';
        array_unshift($links, $settings);
        
        return $links;
    }
    
    function get_started_headline(){

        // Don't display this error as we're upgrading the thing... cmon
        if(isset($_GET['action']) and $_GET['action'] == 'upgrade-plugin' and !isset($_GET['activate']))
            return;

        global $frm_ajax_url, $frm_update, $frm_payment_update;
        $db_version = get_option('frm_pay_db_version');
        if((int)$db_version < 1){ //this number should match the db_version in FrmPaymentDb.php
?>
<div class="error" id="frmpay_install_message" style="padding:7px;"><?php _e('Your Formidable Payments database needs to be updated.<br/>Please deactivate and reactivate the plugin to fix this or', 'formidable'); ?> <a id="frmpay_install_link" href="javascript:frmpay_install_now()"><?php _e('Update Now', 'formidable') ?></a></div>  
<script type="text/javascript">
function frmpay_install_now(){ 
jQuery('#frmpay_install_link').replaceWith('<img src="<?php echo FRM_IMAGES_URL; ?>/wpspin_light.gif" alt="<?php _e('Loading...', 'formidable'); ?>" />');
jQuery.ajax({type:"POST",url:"<?php echo $frm_ajax_url ?>",data:"action=frmpay_install",
success:function(msg){jQuery("#frmpay_install_message").fadeOut("slow");}
});
};
</script>
<?php
        }
    }
    
    function include_updater(){
        if(!class_exists('FrmUpdate')) return;

        include_once(FRM_PAYMENT_PATH.'/models/FrmPaymentUpdate.php');
        global $frm_payment_update;
        $frm_payment_update = new FrmPaymentUpdate();
    }
    
    function install($old_db_version=false){
        global $frm_payment_db;
        $frm_payment_db->upgrade($old_db_version);
    }
    
    function show($id){
        global $wpdb, $frm_payment_db, $frmdb;
        if(!$id)
            die(__('Please select a payment to view'));
        $payment = $wpdb->get_row("SELECT p.*, e.user_id FROM $frm_payment_db->payments p LEFT JOIN $frmdb->entries e ON (p.item_id = e.id) WHERE p.id=$id");
        
        include(FRM_PAYMENT_PATH .'/views/payments/show.php');
    }
    
    function display_list(){
        
        if(!class_exists('WP_List_Table'))
            die(__('Please upgrade to at least WordPress v3.1 to see your payments'));
            
        include_once( FRM_PAYMENT_PATH . "/helpers/FrmPaymentsListHelper.php" );
        $title = __('Downloads');
        $wp_list_table = new FrmPaymentsListHelper();
        
        $pagenum = $wp_list_table->get_pagenum();
        
        $wp_list_table->prepare_items();

        $total_pages = $wp_list_table->get_pagination_arg( 'total_pages' );
        if ( $pagenum > $total_pages && $total_pages > 0 ) {
        	wp_redirect( add_query_arg( 'paged', $total_pages ) );
        	exit;
        }

        include(FRM_PAYMENT_PATH .'/views/payments/list.php');
    }

    function redirect_for_payment($entry_id, $form_id){
        if (isset($_POST) and isset($_POST['frm_payment'])){
            global $frm_payment_settings, $frm_siteurl, $wpdb, $frm_payment_db;
            
            if(isset($_POST['frm_payment']['amount_field']) and isset($_POST['item_meta'][$_POST['frm_payment']['amount_field']])){
                $currencies = FrmPaymentsHelper::get_currencies();
                preg_match_all('/[0-9,]*\.?[0-9]+/', $_POST['item_meta'][$_POST['frm_payment']['amount_field']], $matches);
                $amount = ($matches) ? end($matches[0]) : 0;
                $amount = round((float)$amount, $currencies[$frm_payment_settings->currency]['decimals']);
            }
            
            $invoice = $wpdb->insert( $frm_payment_db->payments, array(
                'item_id' => $entry_id, 'amount' => (float)$amount,
                'paysys' => 'paypal', 'begin_date' => current_time('mysql', 1),
                'created_at' => current_time('mysql', 1)
            ) );
            //TODO: add expire_date for subscriptions
            
            if($invoice)
                $invoice = $wpdb->insert_id;
            else
                $invoice = $form_id.'_'. $entry_id;

        	$paypal_url = ($frm_payment_settings->environment == 'sandbox') ? 
        	    'https://www.sandbox.paypal.com/cgi-bin/webscr/' : 
        	    'https://www.paypal.com/cgi-bin/webscr/';
        	    
        	$paypal_url .= "?cmd=_xclick";
        	$paypal_url .= "&notify_url=". urlencode(FRM_SCRIPT_URL . "&controller=payments&action=paypal_ipn");
        	$paypal_url .= "&business=". urlencode($frm_payment_settings->business_email);
            $paypal_url .= "&currency_code=". urlencode($frm_payment_settings->currency);
            $paypal_url .= '&return='. urlencode($frm_payment_settings->return_url); 
            $paypal_url .= '&cancel_return='. urlencode($frm_payment_settings->cancel_url); 
            $paypal_url .= "&invoice=". urlencode($invoice);
            $paypal_url .= "&custom=". $entry_id.'|'. wp_hash($entry_id);

            if(isset($amount))
                $paypal_url .= "&amount=". urlencode($amount);
            
            
            if(!isset($_POST['frm_payment']['item_name']) or $_POST['frm_payment']['item_name'] == ''){
                global $frmdb;
                $_POST['frm_payment']['item_name'] = $frmdb->get_var($frmdb->forms, array('id' => $form_id), 'name');
            }
            $paypal_url .= "&item_name=". urlencode($_POST['frm_payment']['item_name']);

            die("<script type='text/javascript'>window.location='$paypal_url';</script>");
        }
    }
    
    
    function paypal_ipn(){
        if(FrmPaymentsHelper::verify_ipn()){ //if ipn is from PayPal
            global $frm_payment_settings;
            extract($_POST);
        
            //Check email address to make sure that this is not a spoof
            if(empty($custom) or (strtolower($business) != strtolower($frm_payment_settings->business_email)))
                return;

            //get entry associated with this payment
            list($entry_id, $hash) = explode("|", $custom);
            
            //validate that Entry Id wasn't tampered with
            if((!isset($test_ipn) or !$test_ipn) and (wp_hash($entry_id) != $hash))
                return;
                
            $entry = FrmEntry::getOne($entry_id);
            
            if(!$entry)
                return;
              
            //mark as paid
            global $frm_payment_db, $frmdb, $wpdb;
            
            $payment = $frmdb->get_one_record($frm_payment_db->payments, array('id' => $invoice, 'item_id' => $entry_id));
            if(!$payment)
                return;
                
            $amt = (isset($payment_gross) and $payment_gross > 0.0) ? $payment_gross : $mc_gross;
            if ($amt != $payment->amount)
                return; //Payment amounts do not match
            
            /*
            TODO: process subscriptions
            switch(strtolower($txn_type)){
                case "subscr_payment" :
                case "subscr_signup" :
                case "subscr_cancel" :
                case "subscr_eot" : //expired
                case "subscr_failed" :
            */

            $pay_vars = (array)$payment;
            if(!$payment->receipt_id)
                $pay_vars['receipt_id'] = $txn_id;
            
            if($pay_vars['meta_value'] and !empty($pay_vars['meta_value']))
                $pay_vars['meta_value'] = maybe_unserialize($pay_vars['meta_value']);
            else
                $pay_vars['meta_value'] = array();
                
            if(!isset($ipn_track_id))
                $ipn_track_id = '';
                
            $pay_vars['meta_value'][$ipn_track_id] = $_POST;
            $pay_vars['meta_value'] = maybe_serialize($pay_vars['meta_value']);
            
            $pay_vars['completed'] = ($payment_status == 'Completed') ? true : false;
            
            if(isset($next_payment_date))
                $pay_vars['expire_date'] = date('Y-m-d H:i:s', strtotime($next_payment_date));
            
            $wpdb->update( $frm_payment_db->payments, $pay_vars, array('id' => $payment->id) );
        }
    }
    
    function hidden_payment_fields($form){
        if(isset($form->options['paypal']) and $form->options['paypal']){
            echo '<input type="hidden" name="frm_payment[item_name]" value="'. $form->options['paypal_item_name'] .'"/>'."\n";
            echo '<input type="hidden" name="frm_payment[amount_field]" value="'. $form->options['paypal_amount_field'] .'"/>'."\n";
        }
    }
    
    function setup_new_vars($values){
        $defaults = FrmPaymentsHelper::get_default_options();
        foreach ($defaults as $opt => $default){
            $values[$opt] = FrmAppHelper::get_param($opt, $default);
            unset($default);
            unset($opt);
        }
        return $values;
    }
    
    function setup_edit_vars($values){
        $defaults = FrmPaymentsHelper::get_default_options();
        foreach ($defaults as $opt => $default){
            if (!isset($values[$opt]))
                $values[$opt] = ($_POST and isset($_POST['options'][$opt])) ? $_POST['options'][$opt] : $default;
            unset($default);
            unset($opt);
        }
        
        if($values['paypal_item_name'] == ''){
            global $frmdb;
            $values['paypal_item_name'] = $frmdb->get_var($frmdb->forms, array('id' => $values['id']), 'name');
        }
        
        return $values;
    }
    
    function update_options($options, $values){
        $defaults = FrmPaymentsHelper::get_default_options();
        
        foreach($defaults as $opt => $default){
            $options[$opt] = (isset($values['options'][$opt])) ? $values['options'][$opt] : $default;
            unset($default);
            unset($opt);
        }

        unset($defaults);
        return $options;
    }
    
    function sidebar_list($entry){
        global $frmdb, $frm_payment_db, $frm_payment_settings;
        
        $payments = $frmdb->get_records($frm_payment_db->payments, array('item_id' => $entry->id), 'created_at DESC', '', 'begin_date,amount,completed');
        
        if(!$payments)
            return;
        
        $date_format = get_option('date_format');    
        $currencies = FrmPaymentsHelper::get_currencies();
        
        include(FRM_PAYMENT_PATH .'/views/payments/sidebar_list.php');
    }
    
    function standalone_route($controller, $action){
        if ($controller == 'payments'){
            if ($action == 'paypal_ipn')
                $this->paypal_ipn();
        }
    }
    
    function route(){
        $action = FrmAppHelper::get_param('action');
        if($action == 'show')
            return $this->show(FrmAppHelper::get_param('id', false));
        else if($action == 'edit')
            return $this->edit();
        else if($action == 'update')
            return $this->update();
        else if($action == 'destroy')
            return $this->destroy();
        else if($action == 'delete')
            return $this->bulk_actions();
        else
            return $this->display_list();
    }
}

?>