<?php
class FrmPaymentSettings{

    var $environment;
    var $business_email;
    var $currency;
    var $return_url;
    var $cancel_url;
    var $ipn_log;

    function FrmPaymentSettings(){
        $this->set_default_options();
    }
    
    function default_options(){
        return array(
            'environment'       => 'live',
            'business_email'    => get_option('admin_email'),
            'currency'          => 'USD',
            'return_url'        => get_option('siteurl'),
            'cancel_url'        => get_option('siteurl'),
            'ipn_log'           => true,
            'ipn_log_file'      => '.ipn_results.log'
        );
    }
    

    function set_default_options(){
        $settings = $this->default_options();
        
        foreach($settings as $setting => $default){
            if(!isset($this->{$setting}))
                $this->{$setting} = $default;
        }
    }

    function validate($params,$errors){
        if(empty($params[ 'frm_business_email' ]) or !is_email($params[ 'frm_business_email' ]))
            $errors[] = "Please enter a valid email address";
        return $errors;
    }

    function update($params){
        $settings = $this->default_options();
        
        foreach($settings as $setting => $default){
            if(isset($params['frm_'. $setting]))
                $this->{$setting} = $params['frm_'. $setting];
        }     
    }

    function store(){
        // Save the posted value in the database
        update_option( 'frm_paypal_options', $this);
    }
  
}
?>