<div class="wrap">
    <div id="icon-options-general" class="icon32"><br/></div>
    <h2><?php _e('Form Payment Settings', 'formidable'); ?></h2>

    <?php require(FRM_VIEWS_PATH.'/shared/errors.php'); ?>

    <?php require(FRM_VIEWS_PATH.'/shared/nav.php'); ?>
    
    <form name="frm_payment_settings_form" method="post" >
        <input type="hidden" name="action" value="process-form" />
        <?php wp_nonce_field('update-payment-options'); ?>

        <table class="form-table">
            <tr class="form-field" valign="top">
                <th><label><?php _e('PayPal Email', 'formidable') ?></label></th>
            	<td>
                    <input name="frm_business_email" id="frm_business_email" value="<?php echo $frm_payment_settings->business_email ?>" class="regular-text" />
        				
            	</td>
            </tr>
            
            <tr class="form-field" valign="top">
                <th><label><?php _e('PayPal Environment', 'formidable') ?></label></th>
            	<td>
                    <select name="frm_environment" id="frm_environment">
                        <option value="live" <?php selected($frm_payment_settings->environment, 'live') ?>><?php _e('Live') ?></option>
                        <option value="sandbox" <?php selected($frm_payment_settings->environment, 'sandbox') ?>><?php _e('Testing') ?></option>
        				
            	</td>
            </tr>
            
            <tr class="form-field" valign="top">
                <th><label><?php _e('Currency', 'formidable') ?></label></th>
            	<td>
            	    <select name="frm_currency" id="frm_currency">
            	    <?php foreach (FrmPaymentsHelper::get_currencies() as $code => $currency){ ?>
                    <option value="<?php echo $code ?>" <?php selected($frm_payment_settings->currency, $code) ?>><?php echo $currency['name'] .' ('. $code .')'; ?></option>
                    <?php 
                        unset($currency);
                        unset($code);
                        } 
                    ?>
            	</td>
            </tr>
            
            <tr class="form-field" valign="top">
                <th><label><?php _e('Return URL', 'formidable') ?></label></th>
            	<td>
                    <input name="frm_return_url" id="frm_return_url" value="<?php echo esc_attr($frm_payment_settings->return_url) ?>" class="frm_long_input"  />
        			<div class="description"><?php _e('The URL for PayPal to send users after purchase', 'formidable') ?></div>
            	</td>
            </tr>
            
            <tr class="form-field" valign="top">
                <th><label><?php _e('Cancel URL', 'formidable') ?></label></th>
            	<td>
                    <input name="frm_cancel_url" id="frm_cancel_url" value="<?php echo esc_attr($frm_payment_settings->cancel_url) ?>" class="frm_long_input"  />
        			<div class="description"><?php _e('The URL for PayPal to send users if they cancel the transaction', 'formidable') ?></div>
            	</td>
            </tr>
        </table>
        
        <p class="submit">
        <input class="button-primary" type="submit" name="Submit" value="<?php _e('Update Options', 'formidable') ?>" />
        </p>

    </form>
</div>
